Index: NEMO/trunk/REFERENCES.bib
===================================================================
--- NEMO/trunk/REFERENCES.bib	(revision 10201)
+++ NEMO/trunk/REFERENCES.bib	(revision 10279)
@@ -1,19 +1,58 @@
-@Book{madec_bk08,
-   title = {NEMO ocean engine},
-   publisher = {Note du P\^ole de mod{\'e}lisation, Institut Pierre-Simon Laplace
-   (IPSL), France, No 27, ISSN No 1288-1619},
-   year = {2008},
-   author = {G. Madec and NEMO System Team}
+@manual{NEMO_manual,
+   title={NEMO ocean engine},
+   author={Madec Gurvan and NEMO System Team},
+   organization={NEMO Consortium},
+   journal={Notes du Pôle de modélisation de l\'Institut Pierre-Simon Laplace (IPSL)},
+   number={27},
+   publisher={Zenodo},
+   abstract={The ocean engine of NEMO is a primitive equation model adapted to regional and
+   global ocean circulation problems.
+   It is intended to be a flexible tool for studying the ocean and its interactions with
+   the others components of the earth climate system over a wide range of space and time scales.},
+   doi={10.5281/zenodo.1464816},
+   edition={},
+   year={}
 }
 
-@Article{gmd-8-2465-2015,
-   author = {Aumont, O. and Eth\'e, C. and Tagliabue, A. and Bopp, L. and Gehlen, M.},
-   title = {{PISCES}-v2: an ocean biogeochemical model for carbon and ecosystem studies},
-   journal = {Geoscientific Model Development},
-   volume = {8},
-   year = {2015},
-   number = {8},
-   pages = {2465--2513},
-   doi = {10.5194/gmd-8-2465-2015}
+@manual{SI3_manual,
+   title={SI³ – Sea Ice modelling Integrated Initiative – The NEMO Sea Ice engine},
+   author={NEMO Sea Ice Working Group},
+   organization={NEMO Consortium},
+   journal={Notes du Pôle de modélisation de l\'Institut Pierre-Simon Laplace (IPSL)},
+   number={31},
+   publisher={Zenodo},
+   abstract={SI³ (Sea Ice modelling Integrated Initiative) is the sea ice engine of NEMO
+   (Nucleus for European Modelling of the Ocean).
+   It is adapted to regional and global sea ice and climate problems.
+   It is intended to be a flexible tool for studying sea ice and its interactions with
+   the other components of the Earth System over a wide range of space and time scales.
+   SI3 is based on the Arctic Ice Dynamics Joint EXperiment (AIDJEX) framework,
+   combining the ice thickness distribution framework, the conservation of horizontal momentum,
+   an elastic-viscous plastic rheology, and energy-conserving halo-thermodynamics.
+   Prognostic variables are the two-dimensional horizontal velocity field, ice volume, area, enthalpy,
+   salt content, snow volume and enthalpy.
+   In the horizontal direction, the model uses a curvilinear orthogonal grid.
+   In the vertical direction, the model uses equally-spaced layers.
+   In thickness space, the model uses thickness categories with prescribed boundaries.
+   Various physical and numerical choices are available to describe sea ice physics.
+   SI3 is interfaced with the NEMO ocean engine, and, via the OASIS coupler, with
+   several atmospheric general circulation models.
+   It also supports two-way grid embedding via the AGRIF software.},
+   doi={10.5281/zenodo.1471689},
+   edition={},
+   year={}
+}
+
+@manual{TOP_manual,
+   title={TOP – Tracers in Ocean Paradigm – The NEMO Tracers engine},
+   author={NEMO TOP Working Group},
+   organization={NEMO Consortium},
+   journal={Notes du Pôle de modélisation de l\'Institut Pierre-Simon Laplace (IPSL)},
+   number={28},
+   publisher={Zenodo},
+   abstract={},
+   doi={10.5281/zenodo.1471700},
+   edition={},
+   year={}
 }
 
@@ -28,26 +67,2 @@
    doi = {10.5194/gmd-8-1245-2015}
 }
-
-@Article{gmd-8-2991-2015,
-   author = {Rousset, C. and Vancoppenolle, M. and Madec, G. and Fichefet, T. and Flavoni, S. and Barth\'elemy, A. and Benshila, R. and Chanut, J. and Levy, C. and Masson, S. and Vivier, F.},
-   title = {The {L}ouvain-la-{N}euve sea ice model {LIM}3.6: global and regional capabilities},
-   journal = {Geoscientific Model Development},
-   volume = {8},
-   year = {2015},
-   number = {10},
-   pages = {2991--3005},
-   doi = {10.5194/gmd-8-2991-2015}
-}
-
-@Article{vancoppenolle200933,
-   title = "Simulating the mass balance and salinity of Arctic and Antarctic sea ice. 1. Model description and validation",
-   journal = "Ocean Modelling",
-   volume = "27",
-   number = "1–2",
-   pages = "33 - 53",
-   year = "2009",
-   issn = "1463-5003",
-   doi = "10.1016/j.ocemod.2008.10.005",
-   author = "Martin Vancoppenolle and Thierry Fichefet and Hugues Goosse and Sylvain Bouillon and Gurvan Madec and Miguel Angel Morales Maqueda",
-   keywords = "sea ice, model, thickness, salinity, age, arctic, antarctic"
-}