Index: NEMO/branches/2018/dev_r9866_HPC_03_globcom/cfgs/AGRIF_DEMO/EXPREF/1_context_nemo.xml
===================================================================
--- NEMO/branches/2018/dev_r9866_HPC_03_globcom/cfgs/AGRIF_DEMO/EXPREF/1_context_nemo.xml	(revision 9871)
+++ NEMO/branches/2018/dev_r9866_HPC_03_globcom/cfgs/AGRIF_DEMO/EXPREF/1_context_nemo.xml	(revision 10289)
@@ -43,90 +43,5 @@
     <domain_definition src="./domain_def_nemo.xml"/>
   
-    <grid_definition>    
-
-        <!--  -->
-       <grid id="grid_T_2D" >
-         <domain id="grid_T" />
-       </grid>
-        <!--  -->
-       <grid id="grid_T_3D_ncatice" >
-         <domain id="grid_T" />
-         <axis id="ncatice" />
-       </grid>
-        <!--  -->
-       <grid id="grid_T_3D" >
-         <domain id="grid_T" />
-         <axis id="deptht" />
-       </grid>
-        <!--  -->
-       <grid id="grid_U_2D" >
-         <domain id="grid_U" />
-       </grid>
-        <!--  -->
-       <grid id="grid_U_3D" >
-         <domain id="grid_U" />
-         <axis id="depthu" />
-       </grid>
-        <!--  -->
-       <grid id="grid_V_2D" >
-         <domain id="grid_V" />
-       </grid>
-        <!--  -->
-       <grid id="grid_V_3D" >
-         <domain id="grid_V" />
-         <axis id="depthv" />
-       </grid>
-        <!--  -->
-       <grid id="grid_W_2D" >
-         <domain id="grid_W" />
-       </grid>
-        <!--  -->
-       <grid id="grid_W_3D" >
-         <domain id="grid_W" />
-         <axis id="depthw" />
-       </grid>
-        <!--  -->
-       <grid id="grid_1point" >
-         <domain domain_ref="1point"/>
-       </grid>
-        <!--  -->
-       <grid id="grid_T_nfloat" >
-         <domain id="grid_T" />
-         <axis id="nfloat" />
-       </grid>
-        <!--  -->
-       <grid id="grid_EqT" >
-         <domain domain_ref="EqT" />
-       </grid>
-        <!--  -->
-       <grid id="grid_znl_T_2D">
-         <domain id="gznl" />
-       </grid>
-        <!--  -->
-       <grid id="grid_znl_T_3D">
-         <domain id="gznl" />
-         <axis id="deptht" />
-       </grid>
-        <!--  -->
-       <grid id="grid_znl_W_3D">
-         <domain id="gznl" />
-         <axis id="depthw" />
-       </grid>
-
-      <grid id="grid_ptr_T_2D">
-       <domain id="ptr" />
-      </grid>
-
-      <grid id="grid_ptr_T_3D">
-       <domain id="ptr" />
-         <axis id="deptht" />
-       </grid>
-
-      <grid id="grid_ptr_W_3D">
-       <domain id="ptr" />
-         <axis id="depthw" />
-      </grid>
-
-    </grid_definition>   
+    <grid_definition src="./grid_def_nemo.xml"/>
 
 </context>
Index: NEMO/branches/2018/dev_r9866_HPC_03_globcom/cfgs/AGRIF_DEMO/EXPREF/1_namelist_cfg
===================================================================
--- NEMO/branches/2018/dev_r9866_HPC_03_globcom/cfgs/AGRIF_DEMO/EXPREF/1_namelist_cfg	(revision 9871)
+++ NEMO/branches/2018/dev_r9866_HPC_03_globcom/cfgs/AGRIF_DEMO/EXPREF/1_namelist_cfg	(revision 10289)
@@ -1,4 +1,4 @@
 !!>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
-!! NEMO/OPA  Configuration namelist : overwrite default values defined in SHARED/namelist_ref
+!! NEMO/OCE  Configuration namelist : overwrite default values defined in SHARED/namelist_ref
 !!>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
 !                         AGRIF ICE configuration                      !
@@ -127,5 +127,5 @@
 &namsbc_rnf    !   runoffs                                              (ln_rnf =T)
 !-----------------------------------------------------------------------
-   ln_rnf_mouth= .true.    !  specific treatment at rivers mouths
+   ln_rnf_mouth = .true.    !  specific treatment at rivers mouths
       rn_hrnf     =  15.e0    !  depth over which enhanced vertical mixing is used    (ln_rnf_mouth=T)
       rn_avt_rnf  =   1.e-3   !  value of the additional vertical mixing coef. [m2/s] (ln_rnf_mouth=T)
Index: NEMO/branches/2018/dev_r9866_HPC_03_globcom/cfgs/AGRIF_DEMO/EXPREF/2_context_nemo.xml
===================================================================
--- NEMO/branches/2018/dev_r9866_HPC_03_globcom/cfgs/AGRIF_DEMO/EXPREF/2_context_nemo.xml	(revision 9871)
+++ NEMO/branches/2018/dev_r9866_HPC_03_globcom/cfgs/AGRIF_DEMO/EXPREF/2_context_nemo.xml	(revision 10289)
@@ -43,90 +43,5 @@
     <domain_definition src="./domain_def_nemo.xml"/>
   
-    <grid_definition>    
-
-        <!--  -->
-       <grid id="grid_T_2D" >
-         <domain id="grid_T" />
-       </grid>
-        <!--  -->
-       <grid id="grid_T_3D_ncatice" >
-         <domain id="grid_T" />
-         <axis id="ncatice" />
-       </grid>
-        <!--  -->
-       <grid id="grid_T_3D" >
-         <domain id="grid_T" />
-         <axis id="deptht" />
-       </grid>
-        <!--  -->
-       <grid id="grid_U_2D" >
-         <domain id="grid_U" />
-       </grid>
-        <!--  -->
-       <grid id="grid_U_3D" >
-         <domain id="grid_U" />
-         <axis id="depthu" />
-       </grid>
-        <!--  -->
-       <grid id="grid_V_2D" >
-         <domain id="grid_V" />
-       </grid>
-        <!--  -->
-       <grid id="grid_V_3D" >
-         <domain id="grid_V" />
-         <axis id="depthv" />
-       </grid>
-        <!--  -->
-       <grid id="grid_W_2D" >
-         <domain id="grid_W" />
-       </grid>
-        <!--  -->
-       <grid id="grid_W_3D" >
-         <domain id="grid_W" />
-         <axis id="depthw" />
-       </grid>
-        <!--  -->
-       <grid id="grid_1point" >
-         <domain domain_ref="1point"/>
-       </grid>
-        <!--  -->
-       <grid id="grid_T_nfloat" >
-         <domain id="grid_T" />
-         <axis id="nfloat" />
-       </grid>
-        <!--  -->
-       <grid id="grid_EqT" >
-         <domain domain_ref="EqT" />
-       </grid>
-        <!--  -->
-       <grid id="grid_znl_T_2D">
-         <domain id="gznl" />
-       </grid>
-        <!--  -->
-       <grid id="grid_znl_T_3D">
-         <domain id="gznl" />
-         <axis id="deptht" />
-       </grid>
-        <!--  -->
-       <grid id="grid_znl_W_3D">
-         <domain id="gznl" />
-         <axis id="depthw" />
-       </grid>
-
-      <grid id="grid_ptr_T_2D">
-       <domain id="ptr" />
-      </grid>
-
-      <grid id="grid_ptr_T_3D">
-       <domain id="ptr" />
-         <axis id="deptht" />
-       </grid>
-
-      <grid id="grid_ptr_W_3D">
-       <domain id="ptr" />
-         <axis id="depthw" />
-      </grid>
-
-    </grid_definition>   
+    <grid_definition src="./grid_def_nemo.xml"/>
 
 </context>
Index: NEMO/branches/2018/dev_r9866_HPC_03_globcom/cfgs/AGRIF_DEMO/EXPREF/2_namelist_cfg
===================================================================
--- NEMO/branches/2018/dev_r9866_HPC_03_globcom/cfgs/AGRIF_DEMO/EXPREF/2_namelist_cfg	(revision 9871)
+++ NEMO/branches/2018/dev_r9866_HPC_03_globcom/cfgs/AGRIF_DEMO/EXPREF/2_namelist_cfg	(revision 10289)
@@ -1,4 +1,4 @@
 !!>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
-!! NEMO/OPA  Configuration namelist : overwrite default values defined in SHARED/1_namelist_ref
+!! NEMO/OCE  Configuration namelist : overwrite default values defined in SHARED/1_namelist_ref
 !!>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
 !                         AGRIF ICE configuration                      !
Index: NEMO/branches/2018/dev_r9866_HPC_03_globcom/cfgs/AGRIF_DEMO/EXPREF/3_context_nemo.xml
===================================================================
--- NEMO/branches/2018/dev_r9866_HPC_03_globcom/cfgs/AGRIF_DEMO/EXPREF/3_context_nemo.xml	(revision 9871)
+++ NEMO/branches/2018/dev_r9866_HPC_03_globcom/cfgs/AGRIF_DEMO/EXPREF/3_context_nemo.xml	(revision 10289)
@@ -43,90 +43,5 @@
     <domain_definition src="./domain_def_nemo.xml"/>
   
-    <grid_definition>    
-
-        <!--  -->
-       <grid id="grid_T_2D" >
-         <domain id="grid_T" />
-       </grid>
-        <!--  -->
-       <grid id="grid_T_3D_ncatice" >
-         <domain id="grid_T" />
-         <axis id="ncatice" />
-       </grid>
-        <!--  -->
-       <grid id="grid_T_3D" >
-         <domain id="grid_T" />
-         <axis id="deptht" />
-       </grid>
-        <!--  -->
-       <grid id="grid_U_2D" >
-         <domain id="grid_U" />
-       </grid>
-        <!--  -->
-       <grid id="grid_U_3D" >
-         <domain id="grid_U" />
-         <axis id="depthu" />
-       </grid>
-        <!--  -->
-       <grid id="grid_V_2D" >
-         <domain id="grid_V" />
-       </grid>
-        <!--  -->
-       <grid id="grid_V_3D" >
-         <domain id="grid_V" />
-         <axis id="depthv" />
-       </grid>
-        <!--  -->
-       <grid id="grid_W_2D" >
-         <domain id="grid_W" />
-       </grid>
-        <!--  -->
-       <grid id="grid_W_3D" >
-         <domain id="grid_W" />
-         <axis id="depthw" />
-       </grid>
-        <!--  -->
-       <grid id="grid_1point" >
-         <domain domain_ref="1point"/>
-       </grid>
-        <!--  -->
-       <grid id="grid_T_nfloat" >
-         <domain id="grid_T" />
-         <axis id="nfloat" />
-       </grid>
-        <!--  -->
-       <grid id="grid_EqT" >
-         <domain domain_ref="EqT" />
-       </grid>
-        <!--  -->
-       <grid id="grid_znl_T_2D">
-         <domain id="gznl" />
-       </grid>
-        <!--  -->
-       <grid id="grid_znl_T_3D">
-         <domain id="gznl" />
-         <axis id="deptht" />
-       </grid>
-        <!--  -->
-       <grid id="grid_znl_W_3D">
-         <domain id="gznl" />
-         <axis id="depthw" />
-       </grid>
-
-      <grid id="grid_ptr_T_2D">
-       <domain id="ptr" />
-      </grid>
-
-      <grid id="grid_ptr_T_3D">
-       <domain id="ptr" />
-         <axis id="deptht" />
-       </grid>
-
-      <grid id="grid_ptr_W_3D">
-       <domain id="ptr" />
-         <axis id="depthw" />
-      </grid>
-
-    </grid_definition>   
+    <grid_definition src="./grid_def_nemo.xml"/>
 
 </context>
Index: NEMO/branches/2018/dev_r9866_HPC_03_globcom/cfgs/AGRIF_DEMO/EXPREF/3_namelist_cfg
===================================================================
--- NEMO/branches/2018/dev_r9866_HPC_03_globcom/cfgs/AGRIF_DEMO/EXPREF/3_namelist_cfg	(revision 9871)
+++ NEMO/branches/2018/dev_r9866_HPC_03_globcom/cfgs/AGRIF_DEMO/EXPREF/3_namelist_cfg	(revision 10289)
@@ -1,4 +1,4 @@
 !!>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
-!! NEMO/OPA  Configuration namelist : overwrite default values defined in SHARED/1_namelist_ref
+!! NEMO/OCE  Configuration namelist : overwrite default values defined in SHARED/1_namelist_ref
 !!>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
 !                         AGRIF ICE configuration                      !
Index: NEMO/branches/2018/dev_r9866_HPC_03_globcom/cfgs/AGRIF_DEMO/EXPREF/context_nemo.xml
===================================================================
--- NEMO/branches/2018/dev_r9866_HPC_03_globcom/cfgs/AGRIF_DEMO/EXPREF/context_nemo.xml	(revision 9871)
+++ NEMO/branches/2018/dev_r9866_HPC_03_globcom/cfgs/AGRIF_DEMO/EXPREF/context_nemo.xml	(revision 10289)
@@ -43,90 +43,5 @@
     <domain_definition src="./domain_def_nemo.xml"/>
   
-    <grid_definition>    
-
-        <!--  -->
-       <grid id="grid_T_2D" >
-         <domain id="grid_T" />
-       </grid>
-        <!--  -->
-       <grid id="grid_T_3D_ncatice" >
-         <domain id="grid_T" />
-         <axis id="ncatice" />
-       </grid>
-        <!--  -->
-       <grid id="grid_T_3D" >
-         <domain id="grid_T" />
-         <axis id="deptht" />
-       </grid>
-        <!--  -->
-       <grid id="grid_U_2D" >
-         <domain id="grid_U" />
-       </grid>
-        <!--  -->
-       <grid id="grid_U_3D" >
-         <domain id="grid_U" />
-         <axis id="depthu" />
-       </grid>
-        <!--  -->
-       <grid id="grid_V_2D" >
-         <domain id="grid_V" />
-       </grid>
-        <!--  -->
-       <grid id="grid_V_3D" >
-         <domain id="grid_V" />
-         <axis id="depthv" />
-       </grid>
-        <!--  -->
-       <grid id="grid_W_2D" >
-         <domain id="grid_W" />
-       </grid>
-        <!--  -->
-       <grid id="grid_W_3D" >
-         <domain id="grid_W" />
-         <axis id="depthw" />
-       </grid>
-        <!--  -->
-       <grid id="grid_1point" >
-         <domain domain_ref="1point"/>
-       </grid>
-        <!--  -->
-       <grid id="grid_T_nfloat" >
-         <domain id="grid_T" />
-         <axis id="nfloat" />
-       </grid>
-        <!--  -->
-       <grid id="grid_EqT" >
-         <domain domain_ref="EqT" />
-       </grid>
-        <!--  -->
-       <grid id="grid_znl_T_2D">
-         <domain id="gznl" />
-       </grid>
-        <!--  -->
-       <grid id="grid_znl_T_3D">
-         <domain id="gznl" />
-         <axis id="deptht" />
-       </grid>
-        <!--  -->
-       <grid id="grid_znl_W_3D">
-         <domain id="gznl" />
-         <axis id="depthw" />
-       </grid>
-
-      <grid id="grid_ptr_T_2D">
-       <domain id="ptr" />
-      </grid>
-
-      <grid id="grid_ptr_T_3D">
-       <domain id="ptr" />
-         <axis id="deptht" />
-       </grid>
-
-      <grid id="grid_ptr_W_3D">
-       <domain id="ptr" />
-         <axis id="depthw" />
-      </grid>
-
-    </grid_definition>   
+    <grid_definition src="./grid_def_nemo.xml"/>
 
 </context>
Index: NEMO/branches/2018/dev_r9866_HPC_03_globcom/cfgs/AGRIF_DEMO/EXPREF/file_def_nemo-ice.xml
===================================================================
--- NEMO/branches/2018/dev_r9866_HPC_03_globcom/cfgs/AGRIF_DEMO/EXPREF/file_def_nemo-ice.xml	(revision 9871)
+++ NEMO/branches/2018/dev_r9866_HPC_03_globcom/cfgs/AGRIF_DEMO/EXPREF/file_def_nemo-ice.xml	(revision 10289)
@@ -5,5 +5,5 @@
 ============================================================================================================
 =                                           output files definition                                        =
-=                                            Define your own files for lim3                                =
+=                                      Define your own files for sea ice                                   =
 =                                         put the variables you want...                                    =
 ============================================================================================================
Index: NEMO/branches/2018/dev_r9866_HPC_03_globcom/cfgs/AGRIF_DEMO/EXPREF/grid_def_nemo.xml
===================================================================
--- NEMO/branches/2018/dev_r9866_HPC_03_globcom/cfgs/AGRIF_DEMO/EXPREF/grid_def_nemo.xml	(revision 10289)
+++ NEMO/branches/2018/dev_r9866_HPC_03_globcom/cfgs/AGRIF_DEMO/EXPREF/grid_def_nemo.xml	(revision 10289)
@@ -0,0 +1,1 @@
+link ../../SHARED/grid_def_nemo.xml
Index: NEMO/branches/2018/dev_r9866_HPC_03_globcom/cfgs/AGRIF_DEMO/EXPREF/namelist_cfg
===================================================================
--- NEMO/branches/2018/dev_r9866_HPC_03_globcom/cfgs/AGRIF_DEMO/EXPREF/namelist_cfg	(revision 9871)
+++ NEMO/branches/2018/dev_r9866_HPC_03_globcom/cfgs/AGRIF_DEMO/EXPREF/namelist_cfg	(revision 10289)
@@ -1,4 +1,4 @@
 !!>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
-!! NEMO/OPA  Configuration namelist : overwrite default values defined in SHARED/namelist_ref
+!! NEMO/OCE  Configuration namelist : overwrite default values defined in SHARED/namelist_ref
 !!>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
 !                         AGRIF ICE configuration                      !
@@ -127,5 +127,5 @@
 &namsbc_rnf    !   runoffs                                              (ln_rnf =T)
 !-----------------------------------------------------------------------
-   ln_rnf_mouth= .true.    !  specific treatment at rivers mouths
+   ln_rnf_mouth = .true.    !  specific treatment at rivers mouths
       rn_hrnf     =  15.e0    !  depth over which enhanced vertical mixing is used    (ln_rnf_mouth=T)
       rn_avt_rnf  =   1.e-3   !  value of the additional vertical mixing coef. [m2/s] (ln_rnf_mouth=T)
Index: NEMO/branches/2018/dev_r9866_HPC_03_globcom/cfgs/AGRIF_DEMO/README.rst
===================================================================
--- NEMO/branches/2018/dev_r9866_HPC_03_globcom/cfgs/AGRIF_DEMO/README.rst	(revision 10289)
+++ NEMO/branches/2018/dev_r9866_HPC_03_globcom/cfgs/AGRIF_DEMO/README.rst	(revision 10289)
@@ -0,0 +1,107 @@
+**********************
+Embedded zooms (AGRIF)
+**********************
+
+.. contents::
+   :local:
+
+Overview
+========
+
+AGRIF (Adaptive Grid Refinement In Fortran) is a library that allows the seamless space and time refinement over
+rectangular regions in NEMO.
+Refinement factors can be odd or even (usually lower than 5 to maintain stability).
+Interaction between grid is "two-ways" in the sense that the parent grid feeds the child grid open boundaries and
+the child grid provides volume averages of prognostic variables once a given number of time step is completed.
+These pages provide guidelines how to use AGRIF in NEMO.
+For a more technical description of the library itself, please refer to http://agrif.imag.fr.
+
+Compilation
+===========
+
+Activating AGRIF requires to append the cpp key ``key_agrif`` at compilation time: 
+
+.. code-block:: sh
+
+	./makenemo add_key 'key_agrif'
+
+Although this is transparent to users, the way the code is processed during compilation is different from
+the standard case:
+a preprocessing stage (the so called "conv" program) translates the actual code so that
+saved arrays may be switched in memory space from one domain to an other.
+
+Definition of the grid hierarchy
+================================
+
+An additional text file ``AGRIF_FixedGrids.in`` is required at run time.
+This is where the grid hierarchy is defined.
+An example of such a file, here taken from the ``ICEDYN`` test case, is given below::
+
+	1
+	34 63 34 63 3 3 3
+	0
+
+The first line indicates the number of zooms (1).
+The second line contains the starting and ending indices in both directions on the root grid
+(imin=34 imax=63 jmin=34 jmax=63) followed by the space and time refinement factors (3 3 3).
+The last line is the number of child grid nested in the refined region (0).
+A more complex example with telescoping grids can be found below and
+in the ``AGRIF_DEMO`` reference configuration directory.
+
+[Add some plots here with grid staggering and positioning ?]
+
+When creating the nested domain, one must keep in mind that the child domain is shifted toward north-east and
+depends on the number of ghost cells as illustrated by the (attempted) drawing below for nbghostcells=1 and
+nbghostcells=3.
+The grid refinement is 3 and nxfin is the number of child grid points in i-direction.  
+
+.. image:: _static/agrif_grid_position.jpg
+
+Note that rectangular regions must be defined so that they are connected to a single parent grid.
+Hence, defining overlapping grids with the same refinement ratio will not work properly,
+boundary data exchange and update being only performed between root and child grids.
+Use of east-west periodic or north-fold boundary conditions is not allowed in child grids either.
+Defining for instance a circumpolar zoom in a global model is therefore not possible. 
+
+Preprocessing
+=============
+
+Knowing the refinement factors and area, a ``NESTING`` pre-processing tool may help to create needed input files
+(mesh file, restart, climatological and forcing files).
+The key is to ensure volume matching near the child grid interface,
+a step done by invoking the ``Agrif_create_bathy.exe`` program.
+You may use the namelists provided in the ``NESTING`` directory as a guide.
+These correspond to the namelists used to create ``AGRIF_DEMO`` inputs.
+
+Namelist options
+================
+
+Each child grid expects to read its own namelist so that different numerical choices can be made
+(these should be stored in the form ``1_namelist_cfg``, ``2_namelist_cfg``, etc... according to their rank in
+the grid hierarchy).
+Consistent time steps and number of steps with the chosen time refinement have to be provided.
+Specific to AGRIF is the following block:
+
+.. code-block:: fortran
+
+	!-----------------------------------------------------------------------
+	&namagrif      !  AGRIF zoom                                            ("key_agrif")
+	!-----------------------------------------------------------------------
+	   ln_spc_dyn    = .true.  !  use 0 as special value for dynamics
+	   rn_sponge_tra = 2880.   !  coefficient for tracer   sponge layer [m2/s]
+	   rn_sponge_dyn = 2880.   !  coefficient for dynamics sponge layer [m2/s]
+	   ln_chk_bathy  = .false. !  =T  check the parent bathymetry
+	/             
+
+where sponge layer coefficients have to be chosen according to the child grid mesh size.
+The sponge area is hard coded in NEMO and applies on the following grid points:
+2 x refinement factor (from i=1+nbghostcells+1 to i=1+nbghostcells+sponge_area) 
+
+References
+==========
+
+.. bibliography:: zooms.bib
+	:all:
+	:style: unsrt
+	:labelprefix: A
+	:keyprefix: a-
Index: NEMO/branches/2018/dev_r9866_HPC_03_globcom/cfgs/AGRIF_DEMO/zooms.bib
===================================================================
--- NEMO/branches/2018/dev_r9866_HPC_03_globcom/cfgs/AGRIF_DEMO/zooms.bib	(revision 10289)
+++ NEMO/branches/2018/dev_r9866_HPC_03_globcom/cfgs/AGRIF_DEMO/zooms.bib	(revision 10289)
@@ -0,0 +1,35 @@
+@article{DEBREU2012,
+   title = "Two-way nesting in split-explicit ocean models: Algorithms, implementation and validation",
+   journal = "Ocean Modelling",
+   volume = "49-50",
+   pages = "1 - 21",
+   year = "2012",
+   issn = "1463-5003",
+   doi = "10.1016/j.ocemod.2012.03.003",
+   author = "Laurent Debreu and Patrick Marchesiello and Pierrick Penven and Gildas Cambon",
+   keywords = "Two-way nesting, Finite difference method, Modeling, Boundary conditions, Coastal upwelling"
+}
+
+@article{PENVEN2006,
+   title = "Evaluation and application of the {ROMS} 1-way embedding procedure to the central california upwelling system",
+   journal = "Ocean Modelling",
+   volume = "12",
+   number = "1",
+   pages = "157 - 187",
+   year = "2006",
+   issn = "1463-5003",
+   doi = "10.1016/j.ocemod.2005.05.002",
+   author = "Pierrick Penven and Laurent Debreu and Patrick Marchesiello and James C. McWilliams",
+   keywords = "Ocean models, Boundary conditions, Embedding, Coastal upwelling, Mesoscale eddies, Eddy kinetic energy, North America, West Coast, Central upwelling system, Monterey Bay, 35–41°N, 128–121°W"
+}
+
+@article{SPALL1991,
+   author = {Spall, Michael A. and Holland, William R.},
+   title = {A Nested Primitive Equation Model for Oceanic Applications},
+   journal = {Journal of Physical Oceanography},
+   volume = {21},
+   number = {2},
+   pages = {205-220},
+   year = {1991},
+   doi = {10.1175/1520-0485(1991)021<0205:ANPEMF>2.0.CO;2},
+}